/*
	Computerized Infrared Remote
	Earle F. Philhower, III
	(c) 1996-8
	
	Software to control the CIR hardware module.  Modifications to:
	earle@ziplabel.com
*/

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <malloc.h>
#include "irdll.h"

#define PPORT (0x378)
#define STATUS (PPORT+1)
#define MAXSAMPLE 50000

unsigned char data[MAXSAMPLE+1];
void Record( unsigned char *data, unsigned int *length )
{
	IRSetPort( 1 );
	IRRecord( data, length );
#if 0
	unsigned int i, j, len;
	unsigned char mask, d;
	

	_disable();

	outp(PPORT,2);
	while ((inp(STATUS)&16)==0);
	while ((inp(STATUS)&16)==16); /* Wait for 1st data */

	for (i=0; i<MAXSAMPLE; i++)
	{
		mask=128;
		d=0;
		for (j=0; j<8; j++)
		{
			if ((inp(STATUS)&16)==0) d |= mask;
			mask=mask>>1;
		}
		data[i]=d;
	}

	outp(PPORT, 0);
	_enable();

	/* Chop off ending zeros */
	for (len=MAXSAMPLE-1; len; len--)
		if (data[len]) break;

	*length = len;
#endif
}


/* Play a sample to IR port */
void Play( unsigned char *data, unsigned int length )
{
	IRSetPort( 1 );
	IRPlay( data, length );
#if 0
	unsigned int i, j;
	unsigned char mask, d;
	
	_disable();
	for (i=0; i<length; i++)
	{
		mask=128;
		d=data[i];
		for (j=0; j<8; j++)
		{
			if (d&mask) outp(PPORT, 1);
			else outp(PPORT,0);
			
			mask=mask>>1;
		}
	}
	_enable();

	outp(PPORT, 0);
#endif
}

int main( int argc, char **argv )
{
	int i;
	char name[32];
	unsigned int len;
	FILE *fp;
	
	if (argc==2)
	{
		printf("Playing...%s\n", argv[1]);
		fp = fopen(argv[1], "rb");
		if (fp==NULL) {printf("ERROR!\n"); return -1; }
		len = fread(data, 1, MAXSAMPLE, fp);
		fclose(fp);
		printf("%d(*8) samples\n", len);
		Play( data, len );
		return 0;
	}
	
	while (1) {
		printf("1. Record\n");
		printf("2. Playback\n");
		printf("3. Exit\n");
		scanf("%d", &i);
		switch(i) {
		case 1:
			printf("filename: ");
			scanf("%s", name);
			Record( data, &len );
			printf("%u(*8) samples\n", len);
			fp = fopen(name, "wb");
			fwrite(data, 1, len, fp);
			fclose(fp);
			break;
		case 2:
			printf("filename: ");
			scanf("%s", name);
			fp = fopen(name, "rb");
			len = fread(data, 1, MAXSAMPLE, fp);
			fclose(fp);
			printf("%u(*8) samples\n", len);
			Play( data, len );
			break;
		case 3:
			return 0;
		}
	}
}	

